function [f_vec1,g_vec1,time_vec1,sample_vec,x,acc_vec] = CG_SBO1(fun_f, fun_g, TSA,param,x0, A1, A2, b1, b2)

% param definition
epsilon_f= param.epsilonf;
epsilon_g= param.epsilong;
lambda = param.lam;
maxiter = param.maxiter;

x = x0;
fun_g_x0 = param.fun_g_x0;
n = length(x0);

a = zeros(n, 1);
% a = A1'*(A1*x-b1);
g = zeros(n, 1);
h = 0;
% g = A2'*(A2*x-b2);
% h = sum_square(A2*x-b2)/2;
K = param.K;
x_prev = x0;
gamma0 = param.gamma;

tic;
% algorithm
iter = 0;
f_vec1 = fun_f(x0);
g_vec1 = fun_g(x0);
time_vec1 = [];
acc_vec = [];
% sample_vec1u = [];
% sample_vec1l = [];
sample_vec = 1e5;
n1 = height(A1);
n2 = height(A2);
while iter <= maxiter
    iter = iter+1;
    gamma = gamma0/(iter+1+10);
%     gamma = 1e-5;
    alpha = 1/(iter);
    % Sample functions
    iter1 = randsample(n1,1);
    iter2 = randsample(n2,1);
%     iter1 = mod(iter, n1)+1;
%     iter2 = mod(iter, n2)+1;
    %fun_fi= @(x) (A1(iter1,:)*x-b1(iter1,:))^2/2;
    fun_gi= @(x) (n2)*sum_square(A2(iter2,:)*x-b2(iter2,:))/2;
    grad_fi= @(x) (n1)*A1(iter1,:)'*(A1(iter1,:)*x-b1(iter1,:));
    grad_gi= @(x) (n2)*A2(iter2,:)'*(A2(iter2,:)*x-b2(iter2,:));
%     fun_gi_x= (A2(iter2,:)*x-b2(iter2,:))^2/2;
%     grad_fi_x= A1(iter1,:)'*(A1(iter1,:)*x-b1(iter1,:));
%     grad_gi_x= A2(iter2,:)'*(A2(iter2,:)*x-b2(iter2,:));
%     fun_gi_x_prev= (A2(iter2,:)*x_prev-b2(iter2,:))^2/2;
%     grad_fi_x_prev= A1(iter1,:)'*(A1(iter1,:)*x_prev-b1(iter1,:));
%     grad_gi_x_prev= A2(iter2,:)'*(A2(iter2,:)*x_prev-b2(iter2,:));
    % Build estimators
    a = (1-alpha)*a + grad_fi(x) - (1-alpha)*grad_fi(x_prev);
    g = (1-alpha)*g + grad_gi(x) - (1-alpha)*grad_gi(x_prev);
    h = (1-alpha)*h + fun_gi(x) - (1-alpha)*fun_gi(x_prev);
%     % Find direction without cutting plane
%     b= lambda;
%     A = [ones(1,2*n)];
%     lb=[sparse(2*n,1)];
%     f=[(a/norm(a))' -(a/norm(a))'];
%     options = optimoptions('linprog','Algorithm','dual-simplex','Display','off');
    % Find direction with cutting plane
    b=[g'*x+fun_g_x0-h+K/(iter+1)^0.5; lambda];
    A = [g' -g'; ones(1,2*n)];
    lb=[sparse(2*n,1)];
    f=[(a/norm(a))' -(a/norm(a))'];
    options = optimoptions('linprog','Algorithm','dual-simplex','Display','off');
    %options = optimoptions('linprog','Algorithm','dual-simplex','Display','iter');
    %%%%%
    vec = linprog(f,A,b,[],[],lb,[],options);
    %%%%%
    d=vec(1:n)-vec(n+1:end);
%     if grad_f(x)'*(x-d)<=epsilon_f && (fun_g(x)-fun_g_x0)<=epsilon_g/2
%         break;
%     end
    x_prev = x;
    x = (1-gamma)*x + gamma*d;

    f_vec1 = [f_vec1;fun_f(x)];
    g_vec1 = [g_vec1;fun_g(x)];
    cpu_t1 = toc;
    time_vec1 = [time_vec1;cpu_t1];
%     sample_vec1u = [sample_vec1u;iter];
%     sample_vec1l = [sample_vec1l;iter];
    sample_vec = [sample_vec;1e5+iter*2];
    % test set accuracy
    [acc_vec] = [acc_vec;TSA(x)];
end

end